<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Apply;
use Models\CompanyPics;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);
try
{
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if ($user->type != '企業') throw new Exception('無權限');
    //dump($user);

    $model = new \Models\ApplyInvitation;
    $model->id = uniqid();
    $model->company_id = $user->id;

    if(\Models\Job::find($data->job_id) == null) throw new Exception('查無此職缺');
    if(\Models\Member::find($data->seeker_id) == null) throw new Exception('查無此求職者');

    $keys = [
        'job_id', 'seeker_id', 'content'
    ];
    foreach ($keys as $k)
    {
        if (property_exists($data, $k)) $model->{$k} = $data->{$k};
    }

    $model->save();

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()], JSON_UNESCAPED_UNICODE);
}


?>
