<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Company.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Member;
use Models\Company;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dump($data);

try
{

    if(Company::where('email', $data->email)->count() > 0)
    {
        throw new Exception('該企業已註冊');
    }
    $data->id = uniqid('c_', true);
    if ($data->banner != '') {
        $imageFileType = strtolower(pathinfo($data->banner->name,PATHINFO_EXTENSION));
        $data->banner = saveFile($data->banner->tmp_name, "images/company/banner/", uniqid() . ".".$imageFileType);
    }
    if ($data->avatar != '') {
        $imageFileType = strtolower(pathinfo($data->avatar->name,PATHINFO_EXTENSION));
        $data->avatar = saveFile($data->avatar->tmp_name, "images/company/avatar/", uniqid() . ".".$imageFileType);
    }
    //更新環境照片
    if (gettype($data->pics) == 'object')
    {
        //dump($data->pics);
        //刪除舊照片
//        foreach ($user->pics as $pic)
//        {
//            unlink($pic->path);
//        }
//        CompanyPics::where('company_id', $user->id)->delete();

        //dump($data->pics);
        foreach ($data->pics->tmp_name as $index => $pic)
        {
            //dump($index);
            $model = new \Models\CompanyPics;
            $model->id = uniqid();
            $model->company_id = $data->id;
            $imageFileType = strtolower(pathinfo($data->pics->name[$index], PATHINFO_EXTENSION));
            //dump($pic);
            $model->path = saveFile($data->pics->tmp_name[$index], "images/company/pics/", uniqid() . "." . $imageFileType);
            $model->save();
        }
    }

//    db_insert('goods', ['id', 'user_id', 'title', 'cover', 'category', 'price', 'location', 'summary', 'oldnew', 'time'], $data);

    $model = new Company;
    $keys = ['id','ubn','name','industry_category_id','charge_p','people','registered_capital','contact','tel','fax','address','website','introduction','service',
        'email','banner','avatar','a1','a2','a3'
        ];
    foreach ($keys as $k)
    {
        $model->{$k} = $data->{$k};
    }
    $model->password = $data->pass1;
    $model->save();

    $uu = new Member;
    $uu->id = $model->id;
    $uu->is_company = 1;
    $uu->save();

//    $citys = \Models\City::distinct()->pluck('city');
//    $result = \Models\City::with('area')->whereIn('city', $citys)->groupBy('city')->orderBy('city_ord', 'asc')->get();

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '']);

}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()], JSON_UNESCAPED_UNICODE);
}


?>
