<?php
header("Content-Type: application/json");
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Member;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);

try
{
    if ($_SERVER['REQUEST_METHOD'] !== 'DELETE') {
        // 請求方法是 POST，執行相應的邏輯
        throw new Exception('不支援的方法');
    }
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if ($user->is_admin != 1) throw new Exception('權限不足');
    $model = \Models\Company::find($data->id);
    if ($model == null) throw new Exception('查無該企業');
    $model->delete();
    echo json_encode(['issue' => 1, 'msg' => '已刪除']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}
?>
