<?php
header("Content-Type: application/json");
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Company;
use Models\CompanyPics;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);
//dump([$data->banner, $data->pics[1]]);
//dump($data);
try
{
    //throw new Exception(gettype($data->avatar));

    $headers = getallheaders();
    //dump($headers);
    $key = str_replace('Bearer ', '', $headers['Authorization']);
//    dump($key);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
//    dump($user);
    if ($user->type != '企業' && $user->is_admin != 1) throw new Exception('權限不足');
    if ($user->is_admin == 1)
    {
        $user = Company::where('id', $data->id)->first();
        if ($user == null) throw new Exception('找不到此企業');
    }
    //dump($user);
    unset($user->type);

    $keys = ['ubn', 'name', 'industry_category_id', 'charge_p', 'people', 'registered_capital', 'contact', 'tel', 'fax', 'address', 'website', 'introduction', 'service',
        'email', 'password', 'a1', 'a2', 'a3','benefits'
    ];
    foreach ($keys as $k)
    {
        if (property_exists($data, $k)) $user->{$k} = $data->{$k};
    }

    //更新大頭貼
    if (gettype($data->avatar) == 'object' && $data->avatar->name != null)
    {
        unlink($user->avatar);
        $imageFileType = strtolower(pathinfo($data->avatar->name, PATHINFO_EXTENSION));
        $user->avatar = saveFile($data->avatar->tmp_name, "images/company/avatar/", uniqid() . "." . $imageFileType);
    }
    //更新banner
    if (gettype($data->banner) == 'object' && $data->banner->name != null)
    {
        unlink($user->banner);
        $imageFileType = strtolower(pathinfo($data->banner->name, PATHINFO_EXTENSION));
        $user->banner = saveFile($data->banner->tmp_name, "images/company/banner/", uniqid() . "." . $imageFileType);
    }
    //dump(gettype($data->pics));
    //更新環境照片
    if (gettype($data->pics) == 'object')
    {
        //dump($data->pics);
        //刪除舊照片
//        foreach ($user->pics as $pic)
//        {
//            unlink($pic->path);
//        }
//        CompanyPics::where('company_id', $user->id)->delete();

        //dump($data->pics);
        foreach ($data->pics->tmp_name as $index => $pic)
        {
            //dump($index);
            $model = new \Models\CompanyPics;
            $model->id = uniqid();
            $model->company_id = $user->id;
            $imageFileType = strtolower(pathinfo($data->pics->name[$index], PATHINFO_EXTENSION));
            //dump($pic);
            $model->path = saveFile($data->pics->tmp_name[$index], "images/company/pics/", uniqid() . "." . $imageFileType);
            $model->save();
        }
    }

    $user->save();
    $user->token = $key;
    $user->type = '企業';

    echo json_encode(['issue' => 1, 'data' => $user, 'msg' => '', 'avatar' => gettype($user->avatar)]);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
