<?php
require_once __DIR__ . "/conn.php";
require __DIR__ . '/vendor/autoload.php';

use Models\CompanySaveUser;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$data = json_decode(json_encode($concat));

try
{
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if($user->is_admin == 1)
    {
        $user = \Models\Company::where('id', $data->user_id)->first();
        if($user == null) throw new Exception('請指定user_id');
    }

    $users = CompanySaveUser::with('user')->where('company_id', '=', $user->id)
        ->orderByDesc('created_at')
        ->paginate(20, ['*'], 'page', intval($data->page));
    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $users, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>