<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/GoodsFollow.php";
require __DIR__ . '/vendor/autoload.php';

use Models\GoodsFollow;
use Models\User;

$json = file_get_contents('php://input');
$data = json_decode($json);

try {

    $model = GoodsFollow::where('user_id', $data->user_id)->where('goods_id', $data->goods_id)->first();
    if ($model == null) {
        $model = new GoodsFollow;
        $model->id = uniqid();
        $model->user_id = $data->user_id;
        $model->goods_id = $data->goods_id;
        $model->save();
    } else {
        $model->delete();
        $model->id = null;
    }
    
    header("Content-Type: application/json");

    $from = \Models\User::find($data->user_id);
    $goods = \Models\Goods::find($data->goods_id);
    addNotice($data->user_id, $goods->user_id, "[{$from->name}]關注了你的商品!");

    echo json_encode(['issue' => 1, 'msg' => '','id'=>  $model->id]);

} catch (Exception $e) {
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
