<?php
require_once __DIR__ . "/conn.php";
require __DIR__ . '/vendor/autoload.php';

use Models\GoodsStar;
use Models\Orders;
use Models\User;
use Models\Goods;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$data = json_decode(json_encode($concat));

try {

    $model = \Models\Orders::find($data->orders_id);
    if ($model == null) {
        throw new Exception('錯誤');
    }

    $goods = \Models\Goods::find($model->goods_id);

    if($data->type != 'buy')
    {
        $model->buy_star = $data->star;
        $data->user_id = $goods->user_id;
    }
    else
    {
        $model->sell_star = $data->star;
        $data->user_id = $model->user_id;
    }
    $model->save();

    header("Content-Type: application/json");

    $from = \Models\User::find($data->user_id);

    addNotice($data->user_id, $goods->user_id, "[{$from->name}] 給你的商品打{$data->star}星");

    $avgStar = GoodsStar::join('goods','goods_star.goods_id','=','goods.id')
        ->where('goods.user_id', $goods->user_id)->avg('star');

    $goodsUser = \Models\User::find($goods->user_id);
    $goodsUser->star = (int)$avgStar;
    $goodsUser->save(); 

    echo json_encode(['issue' => 1, 'msg' => '']);

} catch (Exception $e) {
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
