<?php
require_once __DIR__ . "/conn.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as Capsule;
use Models\Job;
use Models\Company;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);

$data = json_decode(json_encode($concat));
//$data->user_id = '1';
//dd($data);
//dump($data);

try
{
    $user_id = '';
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null)
    {
        $user_id = 'xx';
    }
    else $user_id = $user->id;

    $query = \Models\Job::leftJoin('member_collect_job', function ($join) use ($user_id)
    {
        $join->on('job.id', '=', 'member_collect_job.job_id')->where('member_collect_job.user_id', $user_id);
    })->leftJoin('company', function ($join) use ($user_id)
    {
        $join->on('job.company_id', '=', 'company.id');
    });

    if ($data->updated_at != '')
    {
        if ($data->updated_at == '三日內')
        {
            $query->whereDate('job.updated_at', '>=', \Carbon\Carbon::now()->addDays(-3));
        }
        if ($data->updated_at == '本日最新')
        {
            $query->whereDate('job.updated_at', '>=', \Carbon\Carbon::today());
        }
        if ($data->updated_at == '一週內')
        {
            $query->whereDate('job.updated_at', '>=', \Carbon\Carbon::now()->addDays(-7));
        }
        if ($data->updated_at == '兩週內')
        {
            $query->whereDate('job.updated_at', '>=', \Carbon\Carbon::now()->addDays(-14));
        }
        if ($data->updated_at == '一個月內')
        {
            $query->whereDate('job.updated_at', '>=', \Carbon\Carbon::now()->addDays(-30));
        }
    }

    //關鍵字
    if ($data->like != null && $data->like != '')
    {
//        $query->where(function ($q) use ($data)
//        {
        $query->where('title', 'like', '%' . $data->like . '%')
            ->orWhere('content', 'like', '%' . $data->like . '%');
//        });
    }
    //工作經驗
    if ($data->portfolio != null && $data->portfolio != '')
    {
        $query->where('portfolio', $data->portfolio);
    }
    //上班班別
    if ($data->work_shift != null && $data->work_shift != '')
    {
        $query->where('work_shift', $data->work_shift);
    }
    //上班地點
    if ($data->area != null && $data->area != '')
    {
        $area = explode(',', $data->area);
//        $query->where(function ($q) use ($area) {
//            foreach ($area as $index=>$p)
//            {
//                $q->orWhere('place','like','%'.$p.'%');
//            }
//        });
        $query->where(function ($q) use ($area) {
            foreach ($area as $index=>$p)
            {
                $q->orWhere('area',$p);
            }
        });
    }
    //職務類別
    if ($data->position != null && $data->position != '')
    {
        $position = explode(',', $data->position);
        $query->where(function ($q) use ($position) {
            foreach ($position as $index=>$p)
            {
                $q->orWhere('position',$p);
            }
        });
    }
    //職務性質
    if ($data->nature != null && $data->nature != '')
    {
        $query->where('nature', $data->nature);
    }
    //薪水種類與範圍
    if ($data->salary_pay_method != null && $data->salary_pay_method != '')
    {
        $query->where('salary_min', '>=', $data->salary_min)->where('salary_max', '<=', $data->salary_max)->where('salary_pay_method', $data->salary_pay_method);
    }
    //職缺特色
    if ($data->features != null && $data->features != '')
    {
        $features = explode(',', $data->features);
        $query->where(function ($q) use ($features) {
            foreach ($features as $index=>$p)
            {
                $q->orWhere('features','like','%'.$p.'%');
            }
        });
    }

    //排序方式
    if ($data->sort != null)
    {
        if ($data->sort == '學歷') $query->orderBy('graduation', $data->direction);
        if ($data->sort == '經歷') $query->orderBy('portfolio', $data->direction);
        if ($data->sort == '刊登時間') $query->orderBy('created_at', $data->direction);
        if ($data->sort == '更新時間') $query->orderBy('updated_at', $data->direction);
    }

    $users = $query->select('job.*', 'member_collect_job.id as isCollect', 'company.name as company')->paginate(10, ['*'], 'page', $data->a);

    foreach ($users as $user)
    {
        $user->paid = $user->salary_pay_method . '-' . number_format($user->salary_min) . ' ~ ' . number_format($user->salary_max);
        if($user->content == '') {$user->content = null; $user->save();}
        if($user->position == '') {$user->position = null; $user->save();}
        if($user->place == '') {$user->place = $user->city.$user->area; $user->save();}
        if($user->place == '') {$user->place = null; $user->save();}
        if($user->paid == '') {$user->paid = null; $user->save();}
        if($user->portfolio == '') {$user->portfolio = null; $user->save();}
        if($user->graduation == '') {$user->graduation = null; $user->save();}
        if($user->job_people == '') {$user->job_people = null; $user->save();}
        if($user->title == '') {$user->title = null; $user->save();}
        if($user->features == '') {$user->features = null; $user->save();}
        if($user->company_id == null) {$user->company_id = \Models\Company::query()->inRandomOrder()->first()->id; $user->save();}
    }

//dd($result);
    header("Content-Type: application/json");

    echo json_encode(['issue' => 1, 'data' => $users, 'msg' => '']);

}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>