<?php
require_once __DIR__ . "/conn.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as Capsule;
use Models\Job;
use Models\MemberCollectJob;
use Models\RecordSeekerVisitJob;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);

$data = json_decode(json_encode($concat));
//$data->user_id = '1';
//dd($data);

try
{
    $headers = getallheaders();
    //dump($headers);
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    //dump($key);
    $user = loginUser($key);

    $job = \Models\Job::where('job.id',$data->id)->with('company:id,name')->leftJoin('member_collect_job', function ($join) use ($data, $user)
    {
        $join->on('job.id', '=', 'member_collect_job.job_id')->where('member_collect_job.user_id', $user->id);
    })->select('job.*', 'member_collect_job.id as isCollect')->first();

    if($user != null && $user->type == '求職者')
    {
        $job->watch++;
        $job->save();
        $model = RecordSeekerVisitJob::where('seeker_id', $user->id)->where('job_id', $job->id)->first();
        if($model == null)
        {
            $model = new \Models\RecordSeekerVisitJob;
            $model->seeker_id = $user->id;
            $model->id = uniqid();
            $model->job_id = $job->id;
        }
        $model->save();
    }

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $job, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
