<?php

namespace Models;

use Illuminate\Database\Eloquent\Model;

/**
 * Created by PhpStorm.
 * User: 123
 * Date: 2016/8/25
 * Time: 上午 10:11
 */
class Job extends Model
{
    public $timestamps = true;
    public $incrementing = false;
    protected $table = 'job';
    protected $primaryKey = 'id';
    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    protected function serializeDate($date)
    {
        return $date->format('Y-m-d H:i:s');
    }

    public function user()
    {
        return $this->hasOne('Models\User', 'id', 'user_id');
    }

    public function imgs()
    {
        return $this->hasMany('Models\TopicImg', 'topic_id', 'id');
    }

    public function replys()
    {
        return $this->hasMany('Models\TopicReply', 'topic_id', 'id')->orderBy('created_at', 'desc');
    }

    public function applys()
    {
        return $this->hasMany('Models\Apply', 'job_id', 'id')->orderBy('created_at', 'desc');
    }

    public function company()
    {
        return $this->hasOne('Models\Company', 'id', 'company_id');
    }
}
