<?php

namespace Models;

use App\Enums\Type;
use Carbon\Carbon;
use DateTime;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use stdClass;

/**
 * Created by PhpStorm.
 * User: 123
 * Date: 2016/8/25
 * Time: 上午 10:11
 */
class PmRoom extends Model
{
    public $timestamps = true;
    public $incrementing = false;
    protected $table = 'pm_room';
    protected $primaryKey = 'id';
    protected function serializeDate($date)
    {
        return $date->format('Y-m-d H:i:s');
    }

    public function pm()
    {
        return $this->hasMany('App\Model\Pm', 'room_id', 'id')->orderBy('created_at', 'desc');
    }

    public function join_seeker()
    {
        return $this->belongsToMany('Models\Member', 'pm_room_rel','room_id','user_id');
    }

    public function join_company()
    {
        return $this->belongsToMany('Models\Company', 'pm_room_rel','room_id','user_id');
    }

    public function last_user()
    {
        return $this->hasOne('Models\Member', 'id', 'last_id');
    }

    public function job()
    {
        return $this->hasOne('Models\Job', 'id', 'job_id');
    }
}
