<?php

namespace Models;

use Carbon\Carbon;
use DateTime;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use JsonSerializable;
use stdClass;
use Models\TopicImg;

/**
 * Created by PhpStorm.
 * User: 123
 * Date: 2016/8/25
 * Time: 上午 10:11
 */
class Topic extends Model
{
    public $timestamps = true;
    public $incrementing = false;
    protected $table = 'topic';
    protected $primaryKey = 'id'; 

    public function user()
    {
        return $this->hasOne('Models\User', 'id', 'user_id');
    }
    
    public function imgs()
    {
        return $this->hasMany('Models\TopicImg', 'topic_id', 'id');
    }   
    
    public function replys()
    {
        return $this->hasMany('Models\TopicReply', 'topic_id', 'id')->orderBy('created_at', 'desc');
    }
}
