<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Orders.php";
require_once __DIR__ . "/models/Goods.php";
require_once __DIR__ . "/models/Pm.php";
require_once __DIR__ . "/models/PmRoom.php";
require_once __DIR__ . "/models/PmRoomRel.php";
require_once __DIR__ . "/models/User.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as DB;
use Models\Goods;
use Models\Orders;
use Models\PmRoom;
use Models\PmRoomRel;
use Models\User;

$json = file_get_contents('php://input');
$data = json_decode($json);

try {
    $model = new Orders;
    $model->id = generateRandomString(8);
    $model->user_id = $data->user_id;
    $model->goods_id = $data->goods_id; 
    $model->payment = $data->payment;
    $model->barter = $data->barter;
    $model->status = '待確認';
    $model->save();

    $goods = Goods::find($data->goods_id);
    $goods->buy_id = $data->user_id;
    $goods->save();

    $goodsUser = User::where('id', $goods->user_id)->first();

    $from = \Models\User::find($data->user_id);
    $goods = \Models\Goods::find($data->goods_id);
    addNotice($data->user_id, $goods->user_id, "[{$from->name}]購買了你的[{$goods->title}]商品!");

    //新增聊天室
    $room_id = mm查詢既有聊天室($data->user_id, $goods->user_id);
    if ($room_id == null) {
        $room_id = generateRandomString(8);
        $pmRoom = new PmRoom;
        $pmRoom->id = $room_id;
        $pmRoom->last_content = $goodsUser->name . '已同意你的邀請';
        $pmRoom->last_id = $goodsUser->id;
        $pmRoom->type = 2;
        $pmRoom->save();
        $pmRoomRel = new PmRoomRel;
        $pmRoomRel->id = generateRandomString(8);
        $pmRoomRel->user_id = $data->user_id;
        $pmRoomRel->room_id = $pmRoom->id;
        $pmRoomRel->save();
        $pmRoomRel = new PmRoomRel;
        $pmRoomRel->id = generateRandomString(8);
        $pmRoomRel->user_id = $goodsUser->id;
        $pmRoomRel->room_id = $pmRoom->id;
        $pmRoomRel->save();
    }

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'msg' => '']);
} catch (Exception $e) {
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}

function mm查詢既有聊天室($id1, $id2)
{
    $res = DB::select("
SELECT
	pm_room_rel.room_id,
	res1.room_id
FROM
	(
	SELECT
		pm_room_rel.room_id
	FROM
		pm_room_rel
		JOIN pm_room ON pm_room.id = pm_room_rel.room_id
	WHERE
		pm_room_rel.user_id = ?
		AND pm_room.type = 2
	) res1
	LEFT JOIN pm_room_rel ON res1.room_id = pm_room_rel.room_id
WHERE
	pm_room_rel.user_id = ?", [$id1, $id2]);
    if (count($res) > 0) {
        return $res[0]->room_id;
    } else return null;
}

?>
