<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require_once __DIR__ . "/models/PmRoom.php";
require_once __DIR__ . "/models/PmRoomRel.php";
require_once __DIR__ . "/models/Pm.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as DB;
use Models\Pm;
use Models\PmRoom;
use Models\PmRoomRel;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$data = json_decode(json_encode($concat));

try
{
    header("Content-Type: application/json");

    $headers = getallheaders();
    //dump($headers);
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    //dump($key);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');

    $pmRoom = PmRoom::find($data->room_id);
    if (mb_strlen($data->content, "utf-8") > 1000) throw new \Exception('字數大於1000，無法發送');
    DB::transaction(function () use ($data, $pmRoom, $user)
    {
        $self = \Models\Member::find($user->id);
        if($self == null) $self = \Models\Company::find($user->id);
        $model = new Pm;
        $model->id = generateRandomString(8);
        $model->content = $data->content;
        $model->from_id = $user->id;
        $model->room_id = $data->room_id;
        $model->save();
//                $model->user = new stdClass;
//                $model->user->id = $self->id;
//                $model->user->name = $self->name;
//                $model->user->avatar = $self->avatar;


        $pmRoom->last_content = mb_substr($data->content, 0, 50, "utf-8");
        $pmRoom->last_id = $model->from_id;
        $pmRoom->save();

        //PmRoomRel::where('user_id', '<>', $self->id)->where('room_id', $pmRoom->id)->update(['unread' => 1]);

        echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '']);
    });


//    echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '']);
}
catch (Exception $e)
{
    header("Content-Type: application/json");
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
