<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require_once __DIR__ . "/models/PmRoom.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as Capsule;
use Models\Goods;
use Models\PmRoom;
use Models\PmRoomRel;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$data = json_decode(json_encode($concat));

try
{
    $headers = getallheaders();
    //dump($headers);
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    //dump($key);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');

    $res1 = [];
    $res1 = queryRoom($user);

    if ($user->type == '企業')
    {
        if ($data->seeker_id != null)
        {
            $seeker = \Models\Member::find($data->seeker_id);
            if ($seeker != null)
            {
                $room_id = mm查詢既有聊天室($data->seeker_id, $user->id);
                if ($room_id == null)
                {
                    $room_id = generateRandomString(12);
                    $pmRoom = new PmRoom;
                    $pmRoom->id = $room_id;
                    $pmRoom->last_content = '';
                    $pmRoom->last_id = $user->id;
                    $pmRoom->type = 1;
                    $pmRoom->save();
                    $pmRoomRel = new PmRoomRel;
                    $pmRoomRel->id = generateRandomString(12);
                    $pmRoomRel->user_id = $user->id;
                    $pmRoomRel->room_id = $pmRoom->id;
                    $pmRoomRel->save();
                    $pmRoomRel = new PmRoomRel;
                    $pmRoomRel->id = generateRandomString(12);
                    $pmRoomRel->user_id = $data->seeker_id;
                    $pmRoomRel->room_id = $pmRoom->id;
                    $pmRoomRel->save();
                    $res1 = queryRoom($user);
                }
            }
        }
    }

    if ($user->type == '求職者')
    {
        if ($data->job_id != null)
        {
            $job = \Models\Job::find($data->job_id);
            if ($job != null)
            {
                $company = \Models\Company::find($job->company_id);
                //dump($company);
                $room_id = mm查詢既有聊天室($company->id, $user->id);
                //dump($room_id);
                if ($room_id == null)
                {
                    $room_id = generateRandomString(12);
                    $pmRoom = new PmRoom;
                    $pmRoom->id = $room_id;
                    $pmRoom->last_content = '';
                    $pmRoom->last_id = $user->id;
                    $pmRoom->job_id = $job->id;
                    $pmRoom->type = 1;
                    $pmRoom->save();
                    $pmRoomRel = new PmRoomRel;
                    $pmRoomRel->id = generateRandomString(12);
                    $pmRoomRel->user_id = $user->id;
                    $pmRoomRel->room_id = $pmRoom->id;
                    $pmRoomRel->save();
                    $pmRoomRel = new PmRoomRel;
                    $pmRoomRel->id = generateRandomString(12);
                    $pmRoomRel->user_id = $company->id;
                    $pmRoomRel->room_id = $pmRoom->id;
                    $pmRoomRel->save();
                    $res1 = queryRoom($user);
                }
            }
        }
    }

    header("Content-Type: application/json");

    echo json_encode(['issue' => 1, 'data' => $res1, 'msg' => '']);

}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}

function queryRoom($userSelf)
{
    $res1 = PmRoom::where('pm_room_rel.user_id', $userSelf->id)
//        ->with('meet:id,title,cover,locate,time,type,isNeedPay,user_id,isEnabledPay')
        ->with('job:id,title,jobcategory,position')
        ->with('join_seeker:id,name,avatar')
        ->with('join_company:id,name,avatar')
        ->join('pm_room_rel', 'pm_room_rel.room_id', '=', 'pm_room.id')
        ->select('pm_room.id','pm_room.job_id', 'pm_room.last_content', 'pm_room.updated_at', 'pm_room.type', 'pm_room.last_id', 'pm_room_rel.unread')
        ->orderBy('pm_room.updated_at', 'desc')
        ->get();
    return $res1;
}

?>
