<?php

require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Resume;
use Models\CompanyPics;

//dump($data->identity);
try
{
    $json = file_get_contents('php://input');
    $json = json_decode($json, true);
    if ($json == null) $json = [];
    $concat = array_merge($json, $_GET);
    $concat = array_merge($concat, $_FILES);
    $concat = array_merge($concat, $_POST);
    $data = json_decode(json_encode($concat));
    $request_method = $_SERVER['REQUEST_METHOD'];

    if ($request_method != 'DELETE') throw new Exception('錯誤的方法');
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if($user->is_admin == 1)
    {
        $user = \Models\Member::where('id', $data->user_id)->first();
        if($user == null) throw new Exception('請指定user_id');
    }

    $model = Resume::find($data->id);
    if ($model == null) throw new Exception('查無此履歷');
    if ($user->id != $model->user_id) throw new Exception('無權限');
    if ($model->canuse == 'Y') throw new Exception('預設履歷不可刪除');
    $model->delete();
    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()], JSON_UNESCAPED_UNICODE);
}
?>
