<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Orders.php";
require_once __DIR__ . "/models/Goods.php";
require_once __DIR__ . "/models/Pm.php";
require_once __DIR__ . "/models/PmRoom.php";
require_once __DIR__ . "/models/PmRoomRel.php";
require_once __DIR__ . "/models/User.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as DB;
use Models\Goods;
use Models\Orders;
use Models\PmRoom;
use Models\PmRoomRel;
use Models\User;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$data = json_decode(json_encode($concat));

try {
    $goods = Goods::find($data->goods_id);
    $goodsUser = User::find($goods->user_id);
    //新增聊天室
    $room_id = mm查詢既有聊天室($data->user_id, $goods->user_id);
    if ($room_id == null) {
        $room_id = generateRandomString(8);
        $pmRoom = new PmRoom;
        $pmRoom->id = $room_id;
        $pmRoom->last_content = $goodsUser->name . '已同意你的邀請';
        $pmRoom->last_id = $goodsUser->id;
        $pmRoom->type = 2;
        $pmRoom->save();
        $pmRoomRel = new PmRoomRel;
        $pmRoomRel->id = generateRandomString(8);
        $pmRoomRel->user_id = $data->user_id;
        $pmRoomRel->room_id = $pmRoom->id;
        $pmRoomRel->save();
        $pmRoomRel = new PmRoomRel;
        $pmRoomRel->id = generateRandomString(8);
        $pmRoomRel->user_id = $goodsUser->id;
        $pmRoomRel->room_id = $pmRoom->id;
        $pmRoomRel->save();
    }

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'msg' => '']);
} catch (Exception $e) {
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}



?>
